package command;

import org.eclipse.jgit.api.Git;
import org.eclipse.jgit.api.errors.GitAPIException;

import java.io.File;
import java.io.IOException;
import java.util.Objects;

public class CommandInit implements Command {

    private String path = "/home/jack/Documents/testrepo";

    public void execute() {

        File dir = new File(path);
        try (Git git = Git.open(dir)) { //Newly initialized repositories have a peculiarity in that no branch has yet been created.
            git.checkout()
                    .setCreateBranch(true)
                    .setOrphan(true)
                    .setName("issues")
                    .call();

            for (File file : Objects.requireNonNull(dir.listFiles())) {
                if (!file.getName().equals(".git")) {
                    file.delete();
                }
            }

            git.add().setUpdate(true).addFilepattern(".").call();
            git.commit().setMessage("initialise issue branch").call();


        } catch (IOException e) {
            System.out.println("Not a git repository - aborting operation");
        } catch (GitAPIException e) {
            e.printStackTrace();
        }

    }
}

//    Ref headRef = git.getRepository().getRef( Constants.HEAD );
//if( headRef == null || headRef.getObjectId() == null ) {
//        // no commit yet
//        }

//        System.out.println(System.getProperty("user.dir"));